--Each .1 is a 10nth of the sound bar. 0 Being nothing and 1 being full.
if maxVol == nil or 0 then
	maxVol = 0.5
end

--Get player class.
local _, class = UnitClass("player")

--Sets the volue of the background sounds.
local function SetVolStealth(vol)
	SetCVar("Sound_MusicVolume", vol)
	--SetCVar("Sound_AmbienceVolume", vol)
end

--Checks current buffs for a buff that matches "buffname".
local function BuffExists(buffname)
	for i = 1, 40 do
		local name = UnitBuff("player",i)

		if name == buffname then
			return true
		end

		if not name then return false end
	end
	return false
end

--Either silents or restores sounds depending on if a buff exists.
local function onEvent(self, event)
	--Checks for Stealth/Imp Stealth/Druid Prowl and changes vol depending on the results.
	if (class == "ROGUE" or class == "DRUID") and maxVol ~= 0 then
		if(BuffExists("Stealth") or BuffExists("Vanish") or BuffExists("Prowl")) then
			SetVolStealth(0)
		else
			SetVolStealth(maxVol)
		end
	end
end

--Gets the addon going on startup and rechecks everything your auras(buffs) change.
local addon = CreateFrame('Frame')
addon:SetScript('OnEvent', onEvent)
addon:RegisterEvent('PLAYER_LOGIN')
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent('UNIT_AURA')

SLASH_SILENT1 = "/silent"

SlashCmdList["SILENT"] = function(str)
	num = tonumber(str)

	if num == nil or num > 1 or num < 0 or str == "" then
		DEFAULT_CHAT_FRAME:AddMessage("Silent Running: Please enter a number inbetween 0 and 1. (/silent .1)")    
	elseif num == 0 then
		DEFAULT_CHAT_FRAME:AddMessage("Silent Running: Turned off. Enter a number higher than zero to reenable.")
		maxVol = num
		onEvent()
	else
		DEFAULT_CHAT_FRAME:AddMessage("Silent Running: Volume set to "..num..".")
		maxVol = num
		onEvent()
	end
end